<?php
// This is part of form_session
// visit www.pdfhacks.com/form_session/
//

require_once('forge_fdf.php');

$our_dir= 'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']);

// leave this blank if we're associating the FDF w/ the PDF via URL
$pdf_form_url= "";

// validate state and check for reset
if( !( array_key_exists( 'state', $_POST ) && $_POST['state']== '2' ) ||
    ( array_key_exists( 'reset', $_GET ) ) )
{ // reset form
  $_POST['state']= '0';
}

// default data; these two arrays must ultimately list all of the fields
// you desire to alter, even if you just want to set the 'hidden' flag;
//
$fdf_data_strings= 
array( 'name' => 'Arthur, King of the Britons',
       'submit_name' => '',
       'name_border' => '',
       'name_border_red' => '',
       
       'quest' => 'I seek the Holy Grail.',
       'submit_quest' => '',
       'quest_border' => '',
       'quest_border_red' => '',

       'color' => 'Blue... no, yellow!',
       'submit_color' => '',
       'color_border' => '',
       'color_border_red' => '',

       'message_red' => '',
       'message_green' => '' );
//
$fdf_data_names= array(); // none of these in this example

// PHP will escape GET POST and Cookie (GPC) data for you, sometimes
if( get_magic_quotes_gpc() ) {
  // strip backslashes from quotes, backslash
  if( array_key_exists( 'name', $_POST ) )
    $_POST['name']= stripslashes($_POST['name']);
  if( array_key_exists( 'quest', $_POST ) )
    $_POST['quest']= stripslashes($_POST['quest']);
  if( array_key_exists( 'color', $_POST ) )
    $_POST['color']= stripslashes($_POST['color']);
}

if( $_POST['state']!= '0' ) {
  // fill form from POST data; otherwise use defaults
  if( array_key_exists( 'name', $_POST ) )
    $fdf_data_strings['name']= $_POST['name'];
  if( array_key_exists( 'quest', $_POST ) )
    $fdf_data_strings['quest']= $_POST['quest'];
  if( array_key_exists( 'color', $_POST ) )
    $fdf_data_strings['color']= $_POST['color'];
}
else { // 'zero' state is simply the 'one' state with values reset to defaults
  $_POST['state']= '1';
}

// create arrays and pack them with field names as desired
//
$fields_hidden= array();
$fields_readonly= array();

// set this to retry the previous state
$retry_b= false;

// work backwards, from last state to first, so that a state can
// easily fall back when the data does not validate
//
// switch on the current state
if( $_POST['state']== '2' ) {

  // first, validate the name
  if( !array_key_exists( 'name', $_POST ) ||
      count(explode( ' ', $_POST['name'] ))< 2 ) 
    { // error; retry
      $_POST['state']= '1';
      $retry_b= true;
    }
  else {
    // done; forward data to an HTML page, to show the report;
    // we could put further data validation here

    // replace PDF form with an HTML page via "FDF forward,"
    // the best way to break out of a PDF form session;
    // the best policy is to _always_ return FDF to a PDF form submission
    //
    $pdf_form_url= $our_dir.'/done.php?name='.urlencode($_POST['name']);
    if( array_key_exists( 'quest', $_POST ) ) {
      $pdf_form_url .= '&quest='.urlencode($_POST['quest']);
    }
    if( array_key_exists( 'color', $_POST ) ) {
      $pdf_form_url .= '&color='.urlencode($_POST['color']);
    }
  }
}
if( $_POST['state']== '1' ) {
  $fields_hidden= 
    array( //'name',
	   'submit_name',
	   'name_border',
	   //'name_border_red',
       
	   //'quest',
	   'submit_quest',
	   'quest_border',
	   'quest_border_red',

	   //'color',
	   //'submit_color',
	   'color_border',
	   'color_border_red' );

  $fields_readonly= 
    array( //'name',
	   'submit_name',
	   'name_border',
	   'name_border_red',
       
	   //'quest',
	   'submit_quest',
	   'quest_border',
	   'quest_border_red',

	   //'color',
	   //'submit_color',
	   'color_border',
	   'color_border_red',

	   'message_red',
	   'message_green' );

  if( $retry_b ) { // catching an error
    $fields_hidden[]= 'message_green';
    if( !array_key_exists( 'name', $_POST ) ) {
      $fdf_data_strings['message_red']= 'You can\'t evade us that easily--  Enter your name!';
    }
    else if( count(explode( ' ', $_POST['name'] ))< 2 ) {
      $fdf_data_strings['message_red']= '~Just~ '.$_POST['name'].'?';
    }
  }
  else {
    $fields_hidden[]= 'name_border_red';
    $fields_hidden[]= 'message_red';
    $fdf_data_strings['message_green']= 'Thank you for your interest in crossing the Bridge of Death.  Please fill out this form and submit it to the gatekeeper.  He will execute you promptly.';
  }

}

// advance the state
if( $_POST['state']== '1' ) {
  $fdf_data_strings['state']= '2';
}
else if( $_POST['state']== '2' ) {
  $fdf_data_strings['state']= '3';
}
else if( $_POST['state']== '3' ) {
  $fdf_data_strings['state']= '4';
}
else { // error
  $fdf_data_strings['state']= '1';
}

// the state is always invisible
$fields_hidden[]= 'state';

if( array_key_exists('debug', $_GET) ) { // show plain text for debugging
  header( 'content-type: text/plain' );
}
else {
  header( 'content-type: application/vnd.fdf' );
}

echo forge_fdf( $pdf_form_url,
		$fdf_data_strings, 
		$fdf_data_names,
		$fields_hidden,
		$fields_readonly );
?>
